function f=GMM_multiP_moment_SARX(parm,Y,L,Q,P,Wg,N,T,flag_decomp)
% Forms GMM moment conditions
% Wg: weighting matrix of GMM
% W: spatial weights
% P: N by N by nP quadratic moments weighting matrices

U = Y-L*parm;       % errors(NT by 1)
glin = Q'*U;        % linear moments

uNT = reshape(U,N,T);
nP = size(P,3);
gquad = zeros(nP,1);
for j = 1:nP
    PuNT = P(:,:,j)*uNT;
    PU = PuNT(:);
    gquad(j) = U'*PU;
end
g = [gquad;glin];
if flag_decomp==0
    f = g;
elseif flag_decomp==1
    WgC = chol(Wg);  % WgC'*WgC = Wg
    f = WgC*g;
else
    error('flag_decomp must be 0 or 1!');    
end

end


